/**
 * @file:   文件描述
 * @author: lzc
 * @date:   2019-03-11
 */

const _ = require('lodash/string')

const getName = name => ({
  value: name,
  camelCase: _.camelCase(name), // 驼峰式
  pascalCase: _.upperFirst(_.camelCase(name)), // 大驼峰
  kebabCase: _.kebabCase(name) // 中横线链接如 test-test
})

module.exports = (api, options) => {
  if (api.invoking) {
    api.extendPackage({
      scripts: {
        add: 'vue invoke hua-cloud-template-generator'
      }
    })
  }
  
  if (!options.isLast) {
    return false
  }
  
  if (options.type || options[options.type]) {
    if (options[options.type]) {
      options.name = options[options.type]
    }
    // 重置名字
    options.name = getName(options.name)
    // 调用模板
    require(`./${options.type}`)(api, options)
  }
}
