/**
 * @file:   文件描述
 * @author: lzc
 * @date:   2019-03-11
 */
module.exports = (api, options) => {
  // 需要生成的文件
  const files = {
    [`./src/views/${options.name.kebabCase}/index.vue`]: `./src/index.vue`,
    [`./src/views/${options.name.kebabCase}/components/${options.name.kebabCase}-cmp.vue`]: `./src/component.vue`
  }
  
  // 渲染
  api.render(files, {
    ...options
  })
  
  // 是否生成路由
  if (options.route) {
    require(`../route`)(api, options)
  }
  
  // 是否生成菜单
  if (options.menu) {
    require(`../menu`)(api, options)
  }
  
  // 渲染完成回调
  api.onCreateComplete(() => {
    console.dir('配置信息', options)
    console.log('文件生成好了')
  })
}
