/**
 * @file:   prompts对话
 * @author: lzc
 * @date:   2019-03-11
 */
const _ = require('lodash/string')

const questions = [
  {
    type: 'list',
    name: 'type',
    message: '你想生成什么啊？',
    choices: [
      {
        name: 'Component 组件',
        value: 'component'
      },
      {
        name: 'View 页面',
        value: 'view'
      },
      {
        name: 'Store 模块',
        value: 'store'
      },
      {
        name: 'Mixin',
        value: 'mixin'
      },
      {
        name: 'Directive 指令',
        value: 'directive'
      },
      {
        name: 'Filter 过滤器',
        value: 'filter'
      }
    ]
  },
  {
    type: 'confirm',
    name: 'isLast',
    message: answers => `请确保你项目中代码已提交，git status 后为 working tree clean 状态，以下操作调用文件生成器很有可能更改你现有的文件。`,
    default: false,
    when: answers => !!answers.type
  },
  {
    type: 'input',
    name: 'name',
    message: '请输入组件名：',
    description: '对于组件的名称，此名称将应用于文件名和导入名。请遵循Vue和JavaScript的命名约定',
    group: 'component',
    validate: input => !!input,
    when: answers => answers.isLast && answers.type === 'component'
  },
  {
    type: 'input',
    name: 'name',
    message: '请输入view名：',
    group: 'view',
    validate: input => !!input,
    when: answers => answers.isLast && answers.type === 'view'
  },
  {
    type: 'input',
    name: 'name',
    message: '请输入store名：',
    group: 'store',
    validate: input => !!input,
    when: answers => answers.isLast && answers.type === 'store'
  },
  {
    type: 'input',
    name: 'name',
    message: '请输入mixin名：',
    group: 'mixin',
    validate: input => !!input,
    when: answers => answers.type === 'mixin'
  },
  {
    type: 'input',
    name: 'name',
    message: '请输入directive名：',
    group: 'directive',
    validate: input => !!input,
    when: answers => answers.type === 'directive'
  },
  {
    type: 'input',
    name: 'name',
    message: 'filter 名，不能用中文',
    group: 'filter',
    validate: input => !!input,
    when: answers => answers.type === 'filter'
  },
  {
    type: 'confirm',
    name: 'global',
    message: answers => `注册全局 ${answers.type} ?`,
    default: false,
    when: answers => answers.isLast && answers.type !== 'view' && answers.type !== 'store'
  },
  {
    type: 'confirm',
    name: 'route',
    message: '是否生成路由？',
    default: false,
    group: 'view',
    when: answers => answers.isLast && answers.type === 'view'
  },
  {
    type: 'input',
    name: 'routeTitle',
    message: '请输入路由title：',
    default: answers => _.startCase(_.toLower(answers.name)),
    group: 'view',
    when: answers => answers.isLast && answers.route
  },
  {
    type: 'confirm',
    name: 'menu',
    message: '是否生成菜单？',
    default: false,
    group: 'view',
    when: answers => answers.isLast && answers.routeTitle
  }
]

module.exports = api => api.scripts.hasOwnProperty('add') ? questions : []
